import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import StrutturaUpdate from './struttura-update.vue';
import StrutturaService from './struttura.service';

type StrutturaUpdateComponentType = InstanceType<typeof StrutturaUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const strutturaSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<StrutturaUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('Struttura Management Update Component', () => {
    let comp: StrutturaUpdateComponentType;
    let strutturaServiceStub: SinonStubbedInstance<StrutturaService>;

    beforeEach(() => {
      route = {};
      strutturaServiceStub = sinon.createStubInstance<StrutturaService>(StrutturaService);
      strutturaServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          strutturaService: () => strutturaServiceStub,
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(StrutturaUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(StrutturaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.struttura = strutturaSample;
        strutturaServiceStub.update.resolves(strutturaSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(strutturaServiceStub.update.calledWith(strutturaSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        strutturaServiceStub.create.resolves(entity);
        const wrapper = shallowMount(StrutturaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.struttura = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(strutturaServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        strutturaServiceStub.find.resolves(strutturaSample);
        strutturaServiceStub.retrieve.resolves([strutturaSample]);

        // WHEN
        route = {
          params: {
            strutturaId: `${strutturaSample.id}`,
          },
        };
        const wrapper = shallowMount(StrutturaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.struttura).toMatchObject(strutturaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        strutturaServiceStub.find.resolves(strutturaSample);
        const wrapper = shallowMount(StrutturaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
